using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.MediaCenter;
using Microsoft.MediaCenter.UI;

namespace MCEMediaManager
{
    /// <summary>
    /// A derived command class that stores a unique Id for easy
    /// cross-reference into a table as well as other extra command
    /// metadata.
    /// </summary>
    public class DetailsCommand : Command
    {
        public DetailsCommand(IMediaItem mediaItem, string description)
            : base(mediaItem, description, null)
        {
        }

        public int ItemId
        {
            get { return itemId; }
            set { itemId = value; }
        }

        public string Type
        {
            get { return actionType; }
            set { actionType = value; }
        }

        public string Value
        {
            get { return actionValue; }
            set { actionValue = value; }
        }

        private int itemId;
        private string actionType;
        private string actionValue;
    }

}
