using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using Microsoft.MediaCenter;
using Microsoft.MediaCenter.UI;

namespace MCEMediaManager
{
    public interface IMediaFilter : IModelItem
    {
        string Name { get; set; }
    }

    public class MediaFilter : ModelItem, IMediaFilter
    {
        private string _Name;

        public string Name
        {
            get { return _Name; }
            set 
            {
                if (_Name != value)
                {
                    _Name = value;
                    FirePropertyChanged("Name");
                    Description = value;
                }
            }
        }
        public MediaFilter()
        {
        }
        public MediaFilter(string newName)
        {
            this.Name = newName;
            this.Description = newName;
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
